/*
 * _gen/svc-Channel_Interface_Hold.h - Header for TpSvcChannelInterfaceHold
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CHANNEL_INTERFACE_HOLD_H__
#define __TP_SVC_CHANNEL_INTERFACE_HOLD_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcChannelInterfaceHold:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcChannelInterfaceHold TpSvcChannelInterfaceHold;

/**
 * TpSvcChannelInterfaceHoldClass:
 *
 * The class of TpSvcChannelInterfaceHold.
 */
typedef struct _TpSvcChannelInterfaceHoldClass TpSvcChannelInterfaceHoldClass;


GType tp_svc_channel_interface_hold_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CHANNEL_INTERFACE_HOLD \
  (tp_svc_channel_interface_hold_get_type ())
#define TP_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_HOLD, TpSvcChannelInterfaceHold))
#define TP_IS_SVC_CHANNEL_INTERFACE_HOLD(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_HOLD))
#define TP_SVC_CHANNEL_INTERFACE_HOLD_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_HOLD, TpSvcChannelInterfaceHoldClass))


typedef void (*tp_svc_channel_interface_hold_get_hold_state_impl) (TpSvcChannelInterfaceHold *self,
                                                                   guint member,
                                                                   DBusGMethodInvocation *context);
void tp_svc_channel_interface_hold_implement_get_hold_state (TpSvcChannelInterfaceHoldClass *klass, tp_svc_channel_interface_hold_get_hold_state_impl impl);


/**
 * tp_svc_channel_interface_hold_return_from_get_hold_state:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *dbus_context,
                                                          guint ret)
;
static inline void
tp_svc_channel_interface_hold_return_from_get_hold_state (DBusGMethodInvocation *dbus_context,
                                                          guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_hold_request_hold_impl) (TpSvcChannelInterfaceHold *self,
                                                                 guint member,
                                                                 gboolean hold,
                                                                 DBusGMethodInvocation *context);
void tp_svc_channel_interface_hold_implement_request_hold (TpSvcChannelInterfaceHoldClass *klass, tp_svc_channel_interface_hold_request_hold_impl impl);


/**
 * tp_svc_channel_interface_hold_return_from_request_hold:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_interface_hold_return_from_request_hold (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_channel_interface_hold_emit_hold_state_changed (gpointer instance,
    const guint  member,
    const guint  state);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CHANNEL_INTERFACE_HOLD_H__*/
