/*
 * _gen/svc-Channel_Interface_Transfer.h - Header for TpSvcChannelInterfaceTransfer
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CHANNEL_INTERFACE_TRANSFER_H__
#define __TP_SVC_CHANNEL_INTERFACE_TRANSFER_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcChannelInterfaceTransfer:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcChannelInterfaceTransfer TpSvcChannelInterfaceTransfer;

/**
 * TpSvcChannelInterfaceTransferClass:
 *
 * The class of TpSvcChannelInterfaceTransfer.
 */
typedef struct _TpSvcChannelInterfaceTransferClass TpSvcChannelInterfaceTransferClass;


GType tp_svc_channel_interface_transfer_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CHANNEL_INTERFACE_TRANSFER \
  (tp_svc_channel_interface_transfer_get_type ())
#define TP_SVC_CHANNEL_INTERFACE_TRANSFER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_TRANSFER, TpSvcChannelInterfaceTransfer))
#define TP_IS_SVC_CHANNEL_INTERFACE_TRANSFER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_TRANSFER))
#define TP_SVC_CHANNEL_INTERFACE_TRANSFER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_TRANSFER, TpSvcChannelInterfaceTransferClass))


typedef void (*tp_svc_channel_interface_transfer_transfer_impl) (TpSvcChannelInterfaceTransfer *self,
                                                                 guint member,
                                                                 guint destination,
                                                                 DBusGMethodInvocation *context);
void tp_svc_channel_interface_transfer_implement_transfer (TpSvcChannelInterfaceTransferClass *klass, tp_svc_channel_interface_transfer_transfer_impl impl);


/**
 * tp_svc_channel_interface_transfer_return_from_transfer:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_transfer_return_from_transfer (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_interface_transfer_return_from_transfer (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}


G_END_DECLS

#endif /* #ifndef __TP_SVC_CHANNEL_INTERFACE_TRANSFER_H__*/
