/*
 * _gen/svc-Channel_Type_Contact_Search.h - Header for TpSvcChannelTypeContactSearch
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH_H__
#define __TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcChannelTypeContactSearch:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcChannelTypeContactSearch TpSvcChannelTypeContactSearch;

/**
 * TpSvcChannelTypeContactSearchClass:
 *
 * The class of TpSvcChannelTypeContactSearch.
 */
typedef struct _TpSvcChannelTypeContactSearchClass TpSvcChannelTypeContactSearchClass;


GType tp_svc_channel_type_contact_search_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CHANNEL_TYPE_CONTACT_SEARCH \
  (tp_svc_channel_type_contact_search_get_type ())
#define TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CHANNEL_TYPE_CONTACT_SEARCH, TpSvcChannelTypeContactSearch))
#define TP_IS_SVC_CHANNEL_TYPE_CONTACT_SEARCH(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CHANNEL_TYPE_CONTACT_SEARCH))
#define TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CHANNEL_TYPE_CONTACT_SEARCH, TpSvcChannelTypeContactSearchClass))


typedef void (*tp_svc_channel_type_contact_search_get_search_keys_impl) (TpSvcChannelTypeContactSearch *self,
                                                                         DBusGMethodInvocation *context);
void tp_svc_channel_type_contact_search_implement_get_search_keys (TpSvcChannelTypeContactSearchClass *klass, tp_svc_channel_type_contact_search_get_search_keys_impl impl);


/**
 * tp_svc_channel_type_contact_search_return_from_get_search_keys:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 * @ret1: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_type_contact_search_return_from_get_search_keys (DBusGMethodInvocation *dbus_context,
                                                                const gchar *ret,
                                                                GHashTable *ret1)
;
static inline void
tp_svc_channel_type_contact_search_return_from_get_search_keys (DBusGMethodInvocation *dbus_context,
                                                                const gchar *ret,
                                                                GHashTable *ret1)
{
  dbus_g_method_return (dbus_context, ret, ret1);
}
typedef void (*tp_svc_channel_type_contact_search_get_search_state_impl) (TpSvcChannelTypeContactSearch *self,
                                                                          DBusGMethodInvocation *context);
void tp_svc_channel_type_contact_search_implement_get_search_state (TpSvcChannelTypeContactSearchClass *klass, tp_svc_channel_type_contact_search_get_search_state_impl impl);


/**
 * tp_svc_channel_type_contact_search_return_from_get_search_state:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_type_contact_search_return_from_get_search_state (DBusGMethodInvocation *dbus_context,
                                                                 guint ret)
;
static inline void
tp_svc_channel_type_contact_search_return_from_get_search_state (DBusGMethodInvocation *dbus_context,
                                                                 guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_type_contact_search_search_impl) (TpSvcChannelTypeContactSearch *self,
                                                                GHashTable *terms,
                                                                DBusGMethodInvocation *context);
void tp_svc_channel_type_contact_search_implement_search (TpSvcChannelTypeContactSearchClass *klass, tp_svc_channel_type_contact_search_search_impl impl);


/**
 * tp_svc_channel_type_contact_search_return_from_search:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_type_contact_search_return_from_search (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_type_contact_search_return_from_search (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_channel_type_contact_search_emit_search_result_received (gpointer instance,
    const guint  contact,
    const GHashTable * values);

void tp_svc_channel_type_contact_search_emit_search_state_changed (gpointer instance,
    const guint  state);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CHANNEL_TYPE_CONTACT_SEARCH_H__*/
